﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Imaging;
using PerlinNoiseShader.PerlinNoise2D;
using PerlinNoiseShader.NoiseBlender;
using PerlinNoiseShader.Simplex2D;
using PerlinNoiseShader.ImprovedNoise;


namespace PerlinNoiseShader
{
    public partial class Page : UserControl
    {
        private WriteableBitmap oWriteableBitmap;
        private PerlinNoiseShaderEffect oPerlinNoiseShaderEffect;
        PerlinNoiseGenerator oPerlinNoiseGenerator;
        private WriteableBitmap b00Bitmap;
        PerlinNoise2DClass oPerlinNoise2DClass;
        ClassicNoise oClassicNoise;
        ImprovedNoiseClass oImprovedNoiseClass;
        int index = 0;
        float z = 0.511f;

        public Page()
		{
			// Required to initialize variables
            InitializeComponent();
            CompositionTarget.Rendering += new EventHandler(CompositionTarget_Rendering);
            Application.Current.Host.Settings.MaxFrameRate = 10;
            //PlasmaImage.Effect = oPerlinNoiseShaderEffect;
           // initImage();
            
		}

        void Page_Loaded(object sender, RoutedEventArgs e)
        {
            //MessageBox.Show("los");
            int width = (int)this.Width;
            int height = (int)this.Height;
            oWriteableBitmap = new WriteableBitmap(width, height);
            oImprovedNoiseClass = new ImprovedNoiseClass(100);
            //oImprovedNoiseClass.singleNoise(z, new Size(0.0165, 0.0165), new Point(0, 0), 1, false, Color.FromArgb(255, 0, 0, 255), Color.FromArgb(255, 255, 255, 255), oWriteableBitmap);
            Rectangle oRectangle = new Rectangle();
            oRectangle.Width = width;
            oRectangle.Height = height;
            LinearGradientBrush oLinearGradientBrush = new LinearGradientBrush();
            oLinearGradientBrush.StartPoint = new Point(0, 0.4);
            oLinearGradientBrush.EndPoint = new Point(0, 1);
            GradientStopCollection oGradientStopCollection = new GradientStopCollection();
            GradientStop oGradientStop = new GradientStop();
            oGradientStop.Color = Color.FromArgb(255, 30, 30, 255);
            oGradientStop.Offset = 0;
            oGradientStopCollection.Add(oGradientStop);
            oGradientStop = new GradientStop();
            oGradientStop.Color = Color.FromArgb(255, 255, 255, 255);
            oGradientStop.Offset = 1;
            oGradientStopCollection.Add(oGradientStop);
            oLinearGradientBrush.GradientStops = oGradientStopCollection;
            oRectangle.Fill = oLinearGradientBrush;
            oWriteableBitmap.Render(oRectangle, null);
            oWriteableBitmap.Invalidate();
            myImage.Source = oWriteableBitmap;




        }
        
        void CompositionTarget_Rendering(object sender, EventArgs e)
        {
            z += 0.02f;
            //oImprovedNoiseClass.singleNoise(z, new Size(0.0165, 0.0165), new Point(0, 0), 1, false, Color.FromArgb(255, 0, 0, 255), Color.FromArgb(255, 255, 255, 255), oWriteableBitmap);
            /*
            if (index == 100)
            {
                MessageBox.Show("ping");
                index = 0;
            }
            index++;
             */
            //throw new NotImplementedException();
        }

        
        

        

        

        

        
    }
}
